de.caff.util.concurrent

## Class PresentFuture<V>

- java.lang.Object
- - de.caff.util.concurrent.PresentFuture<V>

- All Implemented Interfaces:
    java.util.concurrent.Future<V>

      public class PresentFuture<V>
      extends java.lang.Object
      implements java.util.concurrent.Future<V>

  A future which is already existing in the present.

  This is thought for situations where normally a Future is awaited, but sometimes the object is already given. It is just a small wrapper around the object.

  Since:
    August.02, 2016
  Author:
    Rammi

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PresentFuture(V value)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `cancel(boolean mayInterruptIfRunning)` Attempts to cancel execution of this task.
    `V` | `get()` Waits if necessary for the computation to complete, and then retrieves its result.
    `V` | `get(long timeout, java.util.concurrent.TimeUnit unit)` Waits if necessary for at most the given time for the computation to complete, and then retrieves its result, if available.
    `boolean` | `isCancelled()` Returns `true` if this task was cancelled before it completed normally.
    `boolean` | `isDone()` Returns `true` if this task completed.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PresentFuture

          public PresentFuture(V value)

      Constructor.
      Parameters:
        `value` - value which is returned by get()

  - ### Method Detail

    - #### cancel

          public boolean cancel(boolean mayInterruptIfRunning)

      Attempts to cancel execution of this task. This attempt will fail if the task has already completed, has already been cancelled, or could not be cancelled for some other reason. If successful, and this task has not started when `cancel` is called, this task should never run. If the task has already started, then the `mayInterruptIfRunning` parameter determines whether the thread executing this task should be interrupted in an attempt to stop the task.

      After this method returns, subsequent calls to `isDone()` will always return `true`. Subsequent calls to `isCancelled()` will always return `true` if this method returned `true`.

      Specified by:
        `cancel` in interface `java.util.concurrent.Future<V>`
      Parameters:
        `mayInterruptIfRunning` - `true` if the thread executing this task should be interrupted; otherwise, in-progress tasks are allowed to complete
      Returns:
        `false` if the task could not be cancelled, typically because it has already completed normally; `true` otherwise

    - #### isCancelled

          public boolean isCancelled()

      Returns `true` if this task was cancelled before it completed normally.
      Specified by:
        `isCancelled` in interface `java.util.concurrent.Future<V>`
      Returns:
        `true` if this task was cancelled before it completed

    - #### isDone

          public boolean isDone()

      Returns `true` if this task completed.

      Completion may be due to normal termination, an exception, or cancellation -- in all of these cases, this method will return `true`.

      Specified by:
        `isDone` in interface `java.util.concurrent.Future<V>`
      Returns:
        `true` if this task completed

    - #### get

          public V get()
                throws java.lang.InterruptedException,
                       java.util.concurrent.ExecutionException

      Waits if necessary for the computation to complete, and then retrieves its result.
      Specified by:
        `get` in interface `java.util.concurrent.Future<V>`
      Returns:
        the computed result
      Throws:
        `java.util.concurrent.CancellationException` - if the computation was cancelled
        `java.util.concurrent.ExecutionException` - if the computation threw an exception
        `java.lang.InterruptedException` - if the current thread was interrupted while waiting

    - #### get

          public V get(long timeout,
                       @NotNull
                       java.util.concurrent.TimeUnit unit)
                throws java.lang.InterruptedException,
                       java.util.concurrent.ExecutionException,
                       java.util.concurrent.TimeoutException

      Waits if necessary for at most the given time for the computation to complete, and then retrieves its result, if available.
      Specified by:
        `get` in interface `java.util.concurrent.Future<V>`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Returns:
        the computed result
      Throws:
        `java.util.concurrent.CancellationException` - if the computation was cancelled
        `java.util.concurrent.ExecutionException` - if the computation threw an exception
        `java.lang.InterruptedException` - if the current thread was interrupted while waiting
        `java.util.concurrent.TimeoutException` - if the wait timed out